#!usr/bin/env python3

import Adafruit_DHT
import sqlite3
import sys
from os.path import dirname

DbDirectory = dirname(__file__).split('/M')[0] + '/SetupInterface/database/Settings.db'
AM2302Sensor = Adafruit_DHT.AM2302
db = sqlite3.connect(DbDirectory)
Hive = int(sys.argv[1])
GPIO = db.execute("SELECT GPIO FROM Humidity WHERE Hive == ?", (Hive, )).fetchone()
if GPIO[0]:
	try:
		Humidity, Temperature = Adafruit_DHT.read_retry(AM2302Sensor, GPIO[0])
		ReadingError = 0
	except:
		print("Reading error for AM2302 from hive number", Hive)
		ReadingError = 1
	if Humidity:
		Offset = db.execute("SELECT Offset FROM Humidity WHERE Hive == ?",
								(Hive, )).fetchone()
		if Offset[0]:
			Humidity = Humidity - float(Offset[0])
		Humidity = round(Humidity, 1)
		db.execute("UPDATE Humidity SET Measurement = ? WHERE Hive = ?",
								(Humidity, Hive))
		db.commit()
		print("Humidity inside hive number", str(Hive) + ":", Humidity, "%")
	elif not ReadingError:
		print("Unable to read AM2302 from hive number", Hive)
else:
	print("AM2302 from hive number", Hive, "has not assigned GPIO")
db.close()
