#!usr/bin/env python3

import sqlite3
import sys
from os.path import dirname

DbDirectory = dirname(__file__).split('/M')[0] + '/SetupInterface/database/Settings.db'
OneWireDirectory = '/sys/bus/w1/devices/'
db = sqlite3.connect(DbDirectory)
Hive = int(sys.argv[1])
ID = db.execute("SELECT ID FROM Temperature WHERE Hive == ?", (Hive, )).fetchone()
if ID[0]:
	try:
		Status = 'Reading'
		SensorFile = open(OneWireDirectory + ID[0] + '/w1_slave', 'r')
		SensorLines = SensorFile.readlines()
		SensorFile.close()
		Status = SensorLines[0].strip()[-3:]
	except:
		print("DS18B20 from hive number", Hive, "was not found")
	if Status == 'YES':
		MeasurePosition = SensorLines[1].find('t=')
		Temp = SensorLines[1][MeasurePosition + 2:]
		Temperature = float(Temp) / 1000
		if Temperature != 85:
			Offset = db.execute("SELECT Offset FROM Temperature WHERE " \
								"Hive == ?",
								(Hive, )).fetchone()
			if Offset[0]:
				Temperature = Temperature - float(Offset[0])
			Temperature = round(Temperature, 1)
			db.execute("UPDATE Temperature SET Measurement = ? " \
								"WHERE Hive = ?",
								(Temperature, Hive))
			db.commit()
			DegreeSign = u"\N{DEGREE SIGN}"
			print("Temperature inside hive number", str(Hive) + ":",
								Temperature,
								DegreeSign + "C")
		else:
			print("Recieved error 85 for DS18B20 from hive number", Hive)	
	elif Status == 'NO':
		print("DS18B20 reading from hive number", Hive, "is not a valid value")
else:
	print("A DS18B20 ID from hive number", Hive, "was not selected")
db.close()
