#!usr/bin/env python3

import thingspeak
import sqlite3
from os.path import dirname, exists
from subprocess import run

def ToThingSpeak(Measure, ChannelNumber, ChannelField):
	ID = db.execute("SELECT ChannelID FROM TS WHERE ChannelNumber == ?",
							 (ChannelNumber, )).fetchone()
	Key = db.execute("SELECT ChannelWriteAPIKey FROM TS WHERE ChannelNumber == ?",
							 (ChannelNumber, )).fetchone()
	Channel = thingspeak.Channel(id = ID, api_key = Key)
	for Attempt in range(5):
		try:
			Channel.update({ChannelField:Measure})
			print("Measurement uploaded successfully")
			return 0
		except:
			print("Connection failed on attempt", Attempt + 1)
	return 1

if __name__ == '__main__':
	DbDirectory = dirname(__file__).split('/Services')[0] + \
						'/SetupInterface/database/Settings.db'
	ScriptsDirectory = dirname(__file__).split('/Services')[0] + '/MeasurementScripts'
	if exists(DbDirectory):
		db = sqlite3.connect(DbDirectory)
		Hives = db.execute("SELECT Hive FROM Humidity").fetchall()
		Script = ScriptsDirectory + '/MeasureAM2302.py'
		for Hive in range(len(Hives)):
			Enabled = db.execute("SELECT Enabled FROM Humidity " \
						 	"WHERE Hive == ?",
							(Hive + 1, )).fetchone()
			Sent = db.execute("SELECT Sent FROM Humidity WHERE Hive == ?",
							 (Hive + 1, )).fetchone()
			if Enabled[0] and not Sent[0]:
				run(["python", Script, str(Hive + 1)])
				Measure = db.execute("SELECT Measurement FROM " \
							"Humidity WHERE Hive == ?",
							 (Hive + 1, )).fetchone()
				if Measure[0]:
					Channel = db.execute("SELECT " \
							"ThingSpeakChannelNumber FROM " \
							"Humidity WHERE Hive == ?",
							 (Hive + 1, )).fetchone()
					Field = db.execute("SELECT " \
							"ThingSpeakChannelField FROM " \
							"Humidity WHERE Hive == ?",
							 (Hive + 1, )).fetchone()
					if Channel[0] and Field[0]:
						Upload = ToThingSpeak(Measure[0],
								      Channel[0],
								      Field[0])
						if Upload == 0:
							db.execute("UPDATE Humidity " \
								"SET Sent = ? " \
								"WHERE Hive = ?",
								(1, Hive + 1))
							db.commit()
							print("Humidity measurement " \
								"from hive number",
								Hive + 1, "has been sent")
					elif not Channel[0]:
						print("Humidity sensor " \
							"from hive number", Hive + 1,
							"has not ThingSpeak " \
							"Channel assigned")
					else:
						print("Humidity sensor " \
							"from hive number", Hive + 1,
							"has not ThingSpeak " \
							"Channel Field assigned")
			elif not Enabled[0]:
				print("Humidity sensor from hive number",
							Hive + 1, "is not enabled")
			else:
				print("Humidity measurement from hive number",
							Hive + 1, "was already sent")
		Hives = db.execute("SELECT Hive FROM Temperature").fetchall()
		Script = ScriptsDirectory + '/MeasureDS18B20.py'
		for Hive in range(len(Hives)):
			Enabled = db.execute("SELECT Enabled FROM Temperature " \
						 	"WHERE Hive == ?",
							 (Hive + 1, )).fetchone()
			Sent = db.execute("SELECT Sent FROM Temperature WHERE Hive == ?",
							 (Hive + 1, )).fetchone()
			if Enabled[0] and not Sent[0]:
				run(["python", Script, str(Hive + 1)])
				Measure = db.execute("SELECT Measurement FROM " \
							"Temperature WHERE Hive == ?",
							 (Hive + 1, )).fetchone()
				if Measure[0]:
					Channel = db.execute("SELECT " \
							"ThingSpeakChannelNumber FROM " \
							"Temperature WHERE Hive == ?",
							 (Hive + 1, )).fetchone()
					Field = db.execute("SELECT " \
							"ThingSpeakChannelField FROM " \
							"Temperature WHERE Hive == ?",
							 (Hive + 1, )).fetchone()
					if Channel[0] and Field[0]:
						Upload = ToThingSpeak(Measure[0],
								      Channel[0],
								      Field[0])
						if Upload == 0:
							db.execute("UPDATE Temperature " \
								"SET Sent = ? " \
								"WHERE Hive = ?",
								(1, Hive + 1))
							db.commit()
							print("Temperature measurement " \
								"from hive number",
								Hive + 1, "has been sent")
					elif not Channel[0]:
						print("Temperature sensor " \
							"from hive number", Hive + 1,
							"has not ThingSpeak " \
							"Channel assigned")
					else:
						print("Temperature sensor " \
							"from hive number", Hive + 1,
							"has not ThingSpeak " \
							"Channel Field assigned")
			elif not Enabled[0]:
				print("Temperature sensor from hive number",
							Hive + 1, "is not enabled")
			else:
				print("Temperature measurement from hive number",
							Hive + 1, "was already sent")
		Hives = db.execute("SELECT Hive FROM Weight").fetchall()
		Script = ScriptsDirectory + '/MeasureHX711.py'
		for Hive in range(len(Hives)):
			Enabled = db.execute("SELECT Enabled FROM Weight " \
						 	"WHERE Hive == ?",
						 	(Hive + 1, )).fetchone()
			Sent = db.execute("SELECT Sent FROM Weight WHERE Hive == ?",
							 (Hive + 1, )).fetchone()
			if Enabled[0] and not Sent[0]:
				run(["python", Script, str(Hive + 1)])
				Measure = db.execute("SELECT Measurement FROM " \
							"Weight WHERE Hive == ?",
							 (Hive + 1, )).fetchone()
				if Measure[0]:
					Channel = db.execute("SELECT " \
							"ThingSpeakChannelNumber FROM " \
							"Weight WHERE Hive == ?",
							 (Hive + 1, )).fetchone()
					Field = db.execute("SELECT " \
							"ThingSpeakChannelField FROM " \
							"Weight WHERE Hive == ?",
							 (Hive + 1, )).fetchone()
					if Channel[0] and Field[0]:
						Upload = ToThingSpeak(Measure[0],
								      Channel[0],
								      Field[0])
						if Upload == 0:
							db.execute("UPDATE Weight " \
								"SET Sent = ? " \
								"WHERE Hive = ?",
								(1, Hive + 1))
							db.commit()
							print("Weight measurement " \
								"from hive number ",
								Hive + 1, "has been sent")
					elif not Channel[0]:
						print("Weight sensor " \
							"from hive number", Hive + 1,
							"has not ThingSpeak " \
							"Channel assigned")
					else:
						print("Weight sensor " \
							"from hive number", Hive + 1,
							"has not ThingSpeak " \
							"Channel Field assigned")
			elif not Enabled[0]:
				print("Weight sensor from hive number",
							Hive + 1, "is not enabled")
			else:
				print("Weight measurement from hive number",
							Hive + 1, "was already sent")
		db.close()
	else:
		print("Settings database was not found")
	run(["shutdown", "-h", "1"])
	UpdateWittyPi = dirname(__file__).split('Services')[0] + '/wittypi/runScript.sh'
	run([UpdateWittyPi])
